<?php
    include_once __ROOT_DIR . '/libs/php-jwt/src/BeforeValidException.php';
    include_once __ROOT_DIR . '/libs/php-jwt/src/ExpiredException.php';
    include_once __ROOT_DIR . '/libs/php-jwt/src/SignatureInvalidException.php';
    include_once __ROOT_DIR . '/libs/php-jwt/src/JWT.php';
    use \Firebase\JWT\JWT;

    class UserController extends Controller {
        public function __construct($name, $request) {
            parent::__construct($name, $request);
        }

        // ==============
        // Actions
        // ==============
        public function processRequest() {
            switch ($this->request->getHttpMethod()) {
                case 'POST':
                    return $this->createUser($_POST);
                break;
                case 'GET':
                    if (empty($this->request->getUriParameters()))
                        return $this->getAllUsers();
                    else 
                        return $this->getUserById($this->request->getUriParameters()[0]);
                break;
                case 'PUT':
                    $put = json_decode(file_get_contents("php://input"));
                    $id = $this->request->getUriParameters()[0];
                    return $this->updateUser($put, $id);
                break;
                case 'DELETE':
                    $id = $this->request->getUriParameters()[0];
                    return $this->deleteUser($id);
                break;
            }
            return Response::errorResponse("unsupported parameters or method in users");
        }

        protected function createUser($post) {
            if (isset($post['email'])) {
                User::create($post);
                $response = Response::okResponse("Utilisateur ajouté");
            }
            else {
                $response = Response::notFoundResponse("Aucun utilisateur ajouté");
            }  

            return $response;
        }

        protected function getAllUsers() {
            $users = User::getList();

            if (!empty($users))
                $response = Response::okResponse(json_encode($users));
            else
                $response = Response::notFoundResponse("Aucune réponse");

            return $response;
        }

        protected function getUserById($id) {
            $user = User::getWithId($id);

            if (!empty($user))
                $response = Response::okResponse(json_encode($user));
            else
                $response = Response::notFoundResponse("Aucune réponse");

            return $response;
        }

        protected function updateUser($put, $id) {
            $user = User::getWithId($id);
            
            // var_dump(Request::getCurrentRequest());

            // if (!empty($put) && !empty($user)) {
            //     try {
            //         $jwt_token = $this->request->getJwtToken();
            //         $decodedJWT = JWT::decode($jwt_token, JWT_BACKEND_KEY, array('HS256'));

            //         var_dump($decodedJWT->data);
            //     } 
            //     catch (Exception $e){
            //         header('WWW-Authenticate: Bearer realm="' . JWT_ISSUER . '"');

            //         $jsonResult =  json_encode(array(
            //             "message" => "Access denied.",
            //             "error" => $e->getMessage()
            //         ));

            //         return Response::unauthorizedResponse($jsonResult);
            //     }
            // }
            // else {
            //     return Response::notFoundResponse("Aucun utilisateur modifié");
            // }  

            // User::update($put, $id);
            // $response = Response::okResponse("Utilisateur modifié");
            // return $response;
        }

        protected function deleteUser($id) {
            $user = User::getWithId($id);

            if (!empty($user)) {
                User::delete($id);
                $response = Response::okResponse("Utilisateur supprimé");
            }
            else {
                $response = Response::notFoundResponse("Aucun utilisateur supprimé");
            }  

            return $response;
        }
    }
?>